import java.io.PrintWriter;
import java.util.*;
import java.util.concurrent.ThreadLocalRandom;

public class GenRandom {

    public final static int SEED = "halfway-there".hashCode();
    public final static Random rng = new Random(SEED);
    public final static int ARGS_COUNT = 2;
    
    public static void main(String[] args) {
        if (args.length < ARGS_COUNT) {
            throw new IllegalArgumentException(
                    String.format("Expected %d arguments, but got %d instead", ARGS_COUNT, args.length));
        }
        rng.setSeed(Arrays.hashCode(args));
        int tests = Integer.parseInt(args[0]);
        long limit = Long.parseLong(args[1]);
        generateRandom(tests, limit);
    }

    static long randomLong(long min, long max) {
        // eh, good enough
        return Math.abs(rng.nextLong()) % (max - min + 1) + min;
    }

    static void generateRandom(int t, long limit) {
        try (PrintWriter out = new PrintWriter(System.out)) {
            out.println(t);
            for (int i = 0; i < t; i++) {
                out.println(randomLong(2, limit));
            }
        }
    }
}
