import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class multiprocessor_va_wa4 {
    public static void main(String[] args) {
        new multiprocessor_va_wa4().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public class Equation {
        String variable;
        int value;

        public Equation(String variable, int value) {
            this.variable = variable;
            this.value = value;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        Equation[][] programs = new Equation[n][];

        for (int i = 0; i < n; i++) {
            int k = nextInt();
            programs[i] = new Equation[k];
            for (int j = 0; j < k; j++) {
                String token = nextToken();
                String[] parts = token.split("=");
                programs[i][k - j - 1] = new Equation(parts[0], Integer.parseInt(parts[1]));
            }
        }

        HashMap<String, Integer> target = new HashMap<>();

        int k = nextInt();
        for (int i = 0; i < k; i++) {
            target.put(nextToken(), nextInt());
        }

        HashMap<String, Integer> goodTarget = new HashMap<>();
        HashMap<String, HashSet<Integer>> allTarget = new HashMap<>();
        int[] eid = new int[programs.length];

        ArrayList<Integer> answer = new ArrayList<>();

        int finished = 0;
        for (int i = 0; i < programs.length; i++) {
            while (eid[i] < programs[i].length && !target.containsKey(programs[i][eid[i]].variable)) {
                answer.add(i);
                eid[i]++;
            }
            if (eid[i] == programs[i].length) {
                finished++;
                continue;
            }
            Equation variable = programs[i][eid[i]];
            if (target.get(variable.variable).equals(variable.value)) {
                goodTarget.put(variable.variable, i);
            }
            allTarget.computeIfAbsent(variable.variable, k1 -> new HashSet<>());
            allTarget.get(variable.variable).add(i);
        }

        while (target.size() > 0 && goodTarget.size() > 0 && finished < programs.length) {
            HashMap<String, Integer> nextGoodTarget = new HashMap<>();
            for (Map.Entry<String, Integer> v : goodTarget.entrySet()) {
                answer.add(v.getValue());
                eid[v.getValue()]++;
                target.remove(v.getKey());

                for (int p : allTarget.get(v.getKey())) {
                    if (eid[p] == programs[p].length) {
                        continue;
                    }
                    while (eid[p] < programs[p].length && !target.containsKey(programs[p][eid[p]].variable)) {
                        answer.add(p);
                        eid[p]++;
                    }
                    if (eid[p] == programs[p].length) {
                        finished++;
                        continue;
                    }
                    Equation variable = programs[p][eid[p]];
                    if (target.get(variable.variable).equals(variable.value)) {
                        nextGoodTarget.put(variable.variable, p);
                    }
                    allTarget.computeIfAbsent(variable.variable, k1 -> new HashSet<>());
                    allTarget.get(variable.variable).add(p);
                }
            }
            goodTarget = nextGoodTarget;
        }

        for (int i = 0; i < n; i++) {
            while (eid[i] != programs[i].length) {
                answer.add(i);
                eid[i]++;
            }
        }

        if (target.size() == 0) {
            out.println("Yes");
            for (int i = answer.size() - 1; i >= 0; i--) {
                out.print((answer.get(i) + 1) + " ");
            }
        } else {
            out.println("No");
        }

    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
