#include "testlib.h"
#include <numeric>
#include <functional>

using namespace std;

int main(int argc, char **argv) {
  registerValidation(argc, argv);
  int n = inf.readInt(2, 100'000, "n");
  inf.readSpace();
  int m  = inf.readInt(1, 200'000, "m");
  inf.readEoln();

  set<pair<int, int>> s;
  vector<int> p(n);
  std::iota(p.begin(), p.end(), 0);
  std::function<int(int)> get = [&](int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
  };

  for (int i = 0; i < m; i++) {
    int a = inf.readInt(1, n, "a");
    inf.readSpace();
    int b = inf.readInt(1, n, "b");
    ensure(a != b);
    inf.readSpace();
    inf.readInt(0, 1'000'000'000, "c");
    inf.readEoln();
    if (!s.emplace(min(a, b), max(a,b)).second) {
      quitf(_fail, "Multiple edge %d %d", a, b);
    }
    p[get(a - 1)] = get(b - 1);
  }
  for (int i = 0; i < n; i++) {
    if (get(i) != get(0)) {
      quitf(_fail, "Not connected");
    }
  }
  inf.readEof();
}
