#include "testlib.h"
#include <string>
#include <map>

using namespace std;

struct equation {
    string variable;
    int value;

    equation(): variable(""), value(0) {}
    equation(string& _var, int _val): variable(_var), value(_val) {}
};

int main(int argc, char * argv[])
{
    registerTestlibCmd(argc, argv);

    string ja = upperCase(ans.readToken());
    string pa = upperCase(ouf.readToken());

    if (pa != "YES" && pa != "NO") {
        quitf(_wa, "wrong first line");
    }

    if (ja == "YES" && pa == "NO") {
        quitf(_wa, "expected %s, found %s", compress(ja).c_str(), compress(pa).c_str());
    }

    if (ja == "NO" && pa == "NO") {
        quitf(_ok, "Ok");
    }

    vector<vector<equation>> programs;

    int total = 0;
    int n = inf.readInt();
    for (int i = 0; i < n; i++) {
        int m = inf.readInt();
        total += m;
        vector<equation> program(m);
        for (int j = 0; j < m; j++) {
            string whole = inf.readToken();
            int pos = whole.find('=');
            string varname = whole.substr(0, pos);
            int varvalue = stoi(whole.substr(pos + 1, whole.length() - pos - 1));
            program[j] = equation(varname, varvalue);
        }
        programs.push_back(program);
    }

    vector<int> eid(n);
    map<string, int> state;
    for (int i = 0; i < total; i++) {
        int p = ouf.readInt() - 1;
        if (p >= n || p < 0) {
            quitf(_wa, "The program's identifier %d is not correct", p + 1);
        }
        if (eid[p] == programs[p].size()) {
            quitf(_wa, "The program %d is finished already", p + 1);
        }
        equation eq = programs[p][eid[p]];
//        cerr << "Equation " << p << " " << eid[p] << " " << eq.variable << " " << eq.value << endl;
        state[eq.variable] = eq.value;
        eid[p]++;
    }

    int m = inf.readInt();
    vector<equation> target(m);
    for (int i = 0; i < m; i++) {
        string var = inf.readToken();
        int value = inf.readInt();

//        cerr << var << " " << value << " " << state[var] << endl;

        if (state[var] != value) {
            quitf(_wa, "The variable %s has value %d instead of %d", compress(var).c_str(), state[var], value);
        }
    }

    if (ja != pa) {
        quitf(_fail, "The participant has found a solution, but jury has not");
    }

    quitf(_ok, "Ok");
}