#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int MAX_P = 100;
int MAX_L = 100;
int MAX_LEN = 10;
int MAX_V = 1000000000;

int main(int argc, char* argv[]) {
  registerValidation(argc, argv);

  set<string> all_vars;

  int p = inf.readInt(1, MAX_P, "t");
  inf.readEoln();
  for (int i = 0; i < p; i++) {
    int l = inf.readInt(1, MAX_L, "l_" + to_string(i + 1));
    inf.readEoln();
    for (int j = 0; j < l; j++) {
      string whole = inf.readToken("[a-z0-9=]*", "assignment[" + to_string(i + 1) + "][" + to_string(j + 1) + "]");
      inf.readEoln();
      int pos = whole.find('=');
      ensuref(pos != string::npos, "Assignment '%s' does not contain the '=' sign", whole.c_str());
      string varname = whole.substr(0, pos);
      ensuref(varname.length() <= MAX_LEN, "Variable %s is longer than 10 characters", varname.c_str());
      ensuref(varname.length() > 0, "Variable in thread %d, assignment %d is empty", i + 1, j + 1);
      for (char x : varname) {
        ensuref('a' <= x && x <= 'z', "Variable %s should consist of lowercase English letters", varname.c_str());
      }
      string varvaluestr = whole.substr(pos + 1, whole.length() - pos - 1);
      for (char c : varvaluestr) {
        ensuref('0' <= c & c <= '9', "Value '%s' should consist of digits only", varvaluestr.c_str());
      }
      ensuref(varvaluestr.length() > 0, "Value in thread %d, assignment %d is empty", i + 1, j + 1);
      ensuref(varvaluestr[0] != '0', "Value %s should not start with 0", varvaluestr.c_str());
      ensuref(varvaluestr.length() <= 10, "Value %s is too long", varvaluestr.c_str());
      long long varvalue = stoll(varvaluestr);
      ensuref(1 <= varvalue && varvalue <= MAX_V, "A value should be inside [1, 1_000_000_000]");
      all_vars.insert(varname);
    }
  }

  int v = inf.readInt((int) all_vars.size(), (int) all_vars.size(), "k");
  inf.readEoln();
  for (int i = 0; i < v; i++) {
    string varname = inf.readToken("[a-z]*", "variable[" + to_string(i + 1) + "]");
    ensuref(all_vars.count(varname) != 0, "The variable name should appear in programs");
    all_vars.erase(varname);
    inf.readSpace();
    int varvalue = inf.readInt(1, MAX_V, "value[" + to_string(i + 1) + "]");
    inf.readEoln();
  }
  inf.readEof();
}