#include "testlib.h"
#include <cassert>
#include <functional>

using namespace std;

struct vertex {
	int white;
	int black;
};

struct test {
	vector<vertex> a;
};

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	int sumN = opt<int>("sumN");
	int maxN = has_opt("n") ? opt<int>("n") : 0;
	bool make_max = opt<bool>("max");
	double from = opt<double>("from");
	double to = opt<double>("to");
	// string type = opt<string>("type");
	vector<test> tests;
	int currentSum = 0;
	while (currentSum < sumN) {
		int n = make_max ? sumN : max(1, min(rnd.next(maxN / 2, maxN), sumN - currentSum));
		// string op = type == "any" ? TYPES[rnd.next(0, (int) TYPES.size() - 1)] : type;
		vector<vertex> a(n);
		for (int i = 0; i < n; i++) {
			a[i].black = rnd.next((int) (from * (n - 1)), (int) (to * (n - 1)));
			a[i].white = rnd.next((int) (from * (n - 1)), (int) (to * (n - 1)));
		}
		tests.push_back({a});
		currentSum += n;
	}
	cout << tests.size() << '\n';
	for (auto &e : tests) {
		cout << e.a.size() << '\n';
		for (auto &v : e.a) {
			cout << v.white << ' ' << v.black << '\n';
		}
	}
}
