#include "testlib.h"

using namespace std;

struct vertex {
	int white;
	int black;
};

struct test {
	vector<vertex> a;
};

test genOk(int n) {
	vector<vertex> a(n);
	for (int i = 1; i < n; i++) {
		int j = rnd.next(0, i - 1);
		if (rnd.next(0, 1) == 0) {
			a[j].white++;
			a[i].white++;
		} else {
			a[j].black++;
			a[i].black++;
		}
	}
	shuffle(a.begin(), a.end());
	return {a};
}

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	int sumN = atoi(argv[1]);
	int maxN = atoi(argv[2]);
	vector<test> tests;
	int currentSum = 0;
	while (currentSum < sumN) {
		int n = min(rnd.next(maxN / 2, maxN), sumN - currentSum);
		tests.push_back(genOk(n));
		currentSum += n;
	}
	cout << tests.size() << '\n';
	for (auto &e : tests) {
		cout << e.a.size() << '\n';
		for (auto &v : e.a) {
			cout << v.white << ' ' << v.black << '\n';
		}
	}
}