#include <bits/stdc++.h>

/**
 * Author: Niyaz Nigmatullin
 */

using namespace std;

struct vertex {
	int white;
	int black;
	int id;
};


struct edge {
	int v;
	int u;
	int color;
};

struct answer {
	bool answerExists;
	vector<edge> ans;
};

answer solve(vector<vertex> const &a) {
	int n = (int) a.size();
	vector<int> whiteUsed(n), blackUsed(n);
	int sumDeg = 0;
	for (auto &e : a) {
		sumDeg += e.white + e.black;
	}
	if (sumDeg != 2 * (n - 1)) {
		return {false, {}};
	}
	vector<int> used(n);
	used[0] = 1;
	vector<edge> ans;
	function<bool()> backtrack = [&]() {
		if ((int) ans.size() == n - 1) {
			return true;
		}
		int v = 0;
		while (v < n && (!used[v] || (blackUsed[v] == a[v].black && whiteUsed[v] == a[v].white))) {
			v++;
		}
		if (v == n) return false;
		for (int i = 0; i < n; i++) {
			if (used[i]) continue;
			used[i] = 1;
			if (blackUsed[i] < a[i].black && blackUsed[v] < a[v].black) {
				ans.push_back({i, v, 1});
				blackUsed[i]++;
				blackUsed[v]++;
				if (backtrack()) return true;
				blackUsed[i]--;
				blackUsed[v]--;
				ans.pop_back();
			}
			if (whiteUsed[i] < a[i].white && whiteUsed[v] < a[v].white) {
				ans.push_back({i, v, 0});
				whiteUsed[i]++;
				whiteUsed[v]++;
				if (backtrack()) return true;
				whiteUsed[v]--;
				whiteUsed[i]--;
				ans.pop_back();
			}
			used[i] = 0;
		}
		return false;
	};
	if (backtrack()) {
		return {true, ans};
	} else {
		return {false, {}};
	}
}

void solveSingleTest() {
	int n;
	cin >> n;
	vector<vertex> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].white >> a[i].black;
		a[i].id = i;
	}
	answer ans = solve(a);
	if (ans.answerExists) {
		cout << "Yes\n";
		for (auto &e : ans.ans) {
			cout << (e.v + 1) << ' ' << (e.u + 1) << ' ' << (e.color == 0 ? "W" : "B") << '\n';
		}
	} else {
		cout << "No\n";
	}
}

int main() {
	ios::sync_with_stdio(false); cin.tie(NULL);
	int t;
	cin >> t;
	for (int ct = 0; ct < t; ct++) {
		solveSingleTest();
	}
}
